static const char *RcsId     = "$Header: /home/cvsadm/cvsroot/fermi/servers/plcaccess/src/PLCaccessClass.cpp,v 1.13 2017-08-21 12:54:37 graziano Exp $";
static const char *TagName   = "$Name:  $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        PLCaccessClass.cpp
//
// description : C++ source for the PLCaccessClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the PLCaccess once per process.
//
// project :     TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.13 $
//
// $Log: PLCaccessClass.cpp,v $
// Revision 1.13  2017-08-21 12:54:37  graziano
// added TopUp_GeV, TopUp_Min_I and booster_board_disabled_xxx attributes
//
// Revision 1.12  2016-01-15 11:21:02  graziano
// added db state and error
//
// Revision 1.11  2014-11-13 09:59:56  graziano
// tango 8.1.2.c and Device_4Impl
//
// Revision 1.10  2010-05-17 08:08:16  zambonl
// ndd
//
// Revision 1.9  2009/11/25 15:41:45  sara
// added reset topup error command
//
// Revision 1.8  2009/11/18 16:53:36  sara
// topup version
//
// Revision 1.7  2008/07/01 13:39:26  sara
// added PLC clock syncronizing command
//
// Revision 1.6  2008/03/17 14:29:56  sara
// Includes access logging and a new attribute: Ramping_condition
//
// Revision 1.5  2007/11/22 16:49:14  sara
// new attributes:Gun_trigger_on, Gun_trigger_interlock_abi, Gun_trigger_access_abi
// enabled database log
//
// Revision 1.4  2007/11/05 10:37:33  sara
// added commands gun_on and gun_off, modified and added signals
//
// Revision 1.3  2007/10/05 09:14:36  sara
// added attribute "version"
//
// Revision 1.2  2007/08/13 10:26:53  sara
// timing thread for receive from PLC timeout
//
// Revision 1.1.1.1  2007/07/02 09:29:34  sara
// Initial release
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <PLCaccess.h>
#include <PLCaccessClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create PLCaccessClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_PLCaccess_class(const char *name) {
		return PLCaccess_ns::PLCaccessClass::init(name);
	}
}


namespace PLCaccess_ns
{
//+----------------------------------------------------------------------------
//
// method : 		Err_topup_rstCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Err_topup_rstCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Err_topup_rstCmd::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->err_topup_rst());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Rst_top_upCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Rst_top_upCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Rst_top_upCmd::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->rst_top_up());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SyncronizeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SyncronizeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SyncronizeClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->syncronize());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Gun_offClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Gun_offClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Gun_offClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->gun_off());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Gun_onClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Gun_onClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Gun_onClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->gun_on());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Echo_db122Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Echo_db122Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Echo_db122Class::execute(): arrived" << endl;

	return insert((static_cast<PLCaccess *>(device))->echo_db122());
}

//+----------------------------------------------------------------------------
//
// method : 		Echo_db121Cmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Echo_db121Cmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Echo_db121Cmd::execute(): arrived" << endl;

	return insert((static_cast<PLCaccess *>(device))->echo_db121());
}

//+----------------------------------------------------------------------------
//
// method : 		Echo_db51Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Echo_db51Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Echo_db51Class::execute(): arrived" << endl;

	return insert((static_cast<PLCaccess *>(device))->echo_db51());
}

//+----------------------------------------------------------------------------
//
// method : 		Echo_db50Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Echo_db50Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Echo_db50Class::execute(): arrived" << endl;

	return insert((static_cast<PLCaccess *>(device))->echo_db50());
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_ack_emeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_ack_emeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_ack_emeClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_ack_eme());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_set_topupClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_set_topupClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_set_topupClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_set_topup());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_close_bst_blClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_close_bst_blClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_close_bst_blClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_close_bst_bl());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_reint_pasvClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_reint_pasvClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_reint_pasvClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_reint_pasv());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_close_1_3Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_close_1_3Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_close_1_3Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_close_1_3());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_open_1_3Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_open_1_3Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_open_1_3Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_open_1_3());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_close_1_2Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_close_1_2Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_close_1_2Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_close_1_2());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_open_1_2Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_open_1_2Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_open_1_2Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_open_1_2());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_close_1_1Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_close_1_1Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_close_1_1Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_close_1_1());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_open_1_1Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_open_1_1Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_open_1_1Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_open_1_1());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_close_13_1Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_close_13_1Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_close_13_1Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_close_13_1());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Confirm_open_13_1Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Confirm_open_13_1Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Confirm_open_13_1Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->confirm_open_13_1());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Del_posto_injCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Del_posto_injCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Del_posto_injCmd::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	((static_cast<PLCaccess *>(device))->del_posto_inj(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Del_posto_boCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Del_posto_boCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Del_posto_boCmd::execute(): arrived" << endl;

	Tango::DevUShort	argin;
	extract(in_any, argin);

	((static_cast<PLCaccess *>(device))->del_posto_bo(argin));
	return new CORBA::Any();
}



//+----------------------------------------------------------------------------
//
// method : 		Open_door_injCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Open_door_injCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Open_door_injCmd::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->open_door_inj());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Open_door_boCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Open_door_boCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Open_door_boCmd::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->open_door_bo());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Ripr_in_injCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Ripr_in_injCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Ripr_in_injCmd::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->ripr_in_inj());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Ripr_in_boostCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Ripr_in_boostCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Ripr_in_boostCmd::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->ripr_in_boost());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Ack_emeCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Ack_emeCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Ack_emeCmd::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->ack_eme());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Set_top_upCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Set_top_upCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Set_top_upCmd::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->set_top_up());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Reint_pasvCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Reint_pasvCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Reint_pasvCmd::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->reint_pasv());
	return new CORBA::Any();
}



//+----------------------------------------------------------------------------
//
// method : 		End_ronda_roofClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *End_ronda_roofClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "End_ronda_roofClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->end_ronda_roof());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Start_ronda_roofClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Start_ronda_roofClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Start_ronda_roofClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->start_ronda_roof());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		End_ronda_sxClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *End_ronda_sxClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "End_ronda_sxClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->end_ronda_sx());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Start_ronda_sxClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Start_ronda_sxClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Start_ronda_sxClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->start_ronda_sx());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		End_ronda_dxClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *End_ronda_dxClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "End_ronda_dxClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->end_ronda_dx());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Start_ronda_dxClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Start_ronda_dxClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Start_ronda_dxClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->start_ronda_dx());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		End_ronda_intClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *End_ronda_intClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "End_ronda_intClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->end_ronda_int());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Start_ronda_intClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Start_ronda_intClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Start_ronda_intClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->start_ronda_int());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		End_ronda_boClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *End_ronda_boClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "End_ronda_boClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->end_ronda_bo());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Start_ronda_boClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Start_ronda_boClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Start_ronda_boClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->start_ronda_bo());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Call_ronda_boClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Call_ronda_boClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Call_ronda_boClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->call_ronda_bo());
	return new CORBA::Any();
}



//+----------------------------------------------------------------------------
//
// method : 		Close_bst_blClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Close_bst_blClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Close_bst_blClass::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->close_bst_bl());
	return new CORBA::Any();
}



//+----------------------------------------------------------------------------
//
// method : 		Close_bst_bts1_3Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Close_bst_bts1_3Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Close_bst_bts1_3Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->close_bst_bts1_3());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Open_bst_bts1_3Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Open_bst_bts1_3Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Open_bst_bts1_3Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->open_bst_bts1_3());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Close_bst_bts1_2Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Close_bst_bts1_2Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Close_bst_bts1_2Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->close_bst_bts1_2());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Open_bst_bts1_2Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Open_bst_bts1_2Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Open_bst_bts1_2Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->open_bst_bts1_2());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Close_bst_bts1_1Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Close_bst_bts1_1Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Close_bst_bts1_1Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->close_bst_bts1_1());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Open_bst_bts1_1Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Open_bst_bts1_1Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Open_bst_bts1_1Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->open_bst_bts1_1());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Close_bst_b13_1Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Close_bst_b13_1Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Close_bst_b13_1Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->close_bst_b13_1());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		Open_bst_b13_1Class::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *Open_bst_b13_1Class::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "Open_bst_b13_1Class::execute(): arrived" << endl;

	((static_cast<PLCaccess *>(device))->open_bst_b13_1());
	return new CORBA::Any();
}



//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
PLCaccessClass *PLCaccessClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		PLCaccessClass::PLCaccessClass(string &s)
// 
// description : 	constructor for the PLCaccessClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
PLCaccessClass::PLCaccessClass(string &s):DeviceClass(s)
{

	cout2 << "Entering PLCaccessClass constructor" << endl;
	set_default_property();
	write_class_property();
	get_class_property();
	
	cout2 << "Leaving PLCaccessClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		PLCaccessClass::~PLCaccessClass()
// 
// description : 	destructor for the PLCaccessClass
//
//-----------------------------------------------------------------------------
PLCaccessClass::~PLCaccessClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		PLCaccessClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
PLCaccessClass *PLCaccessClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new PLCaccessClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

PLCaccessClass *PLCaccessClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		PLCaccessClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void PLCaccessClass::command_factory()
{
	command_list.push_back(new Open_bst_b13_1Class("Open_bst_b13_1",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Close_bst_b13_1Class("Close_bst_b13_1",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Open_bst_bts1_1Class("Open_bst_bts1_1",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Close_bst_bts1_1Class("Close_bst_bts1_1",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Open_bst_bts1_2Class("Open_bst_bts1_2",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Close_bst_bts1_2Class("Close_bst_bts1_2",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Open_bst_bts1_3Class("Open_bst_bts1_3",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Close_bst_bts1_3Class("Close_bst_bts1_3",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Del_posto_boCmd("Del_posto_bo",
		Tango::DEV_USHORT, Tango::DEV_VOID,
		"places of name to be deleted",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Reint_pasvCmd("Reint_pasv",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Close_bst_blClass("Close_bst_bl",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Set_top_upCmd("Set_top_up",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Ack_emeCmd("Ack_eme",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Call_ronda_boClass("Call_ronda_bo",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Start_ronda_boClass("Start_ronda_bo",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new End_ronda_boClass("End_ronda_bo",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Start_ronda_intClass("Start_ronda_int",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new End_ronda_intClass("End_ronda_int",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Start_ronda_dxClass("Start_ronda_dx",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new End_ronda_dxClass("End_ronda_dx",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Start_ronda_sxClass("Start_ronda_sx",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new End_ronda_sxClass("End_ronda_sx",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Start_ronda_roofClass("Start_ronda_roof",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new End_ronda_roofClass("End_ronda_roof",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Ripr_in_boostCmd("Ripr_in_boost",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Ripr_in_injCmd("Ripr_in_inj",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Open_door_boCmd("Open_door_bo",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Open_door_injCmd("Open_door_inj",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Del_posto_injCmd("Del_posto_inj",
		Tango::DEV_USHORT, Tango::DEV_VOID,
		"place of name to be deleted",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_open_13_1Class("Confirm_open_13_1",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_close_13_1Class("Confirm_close_13_1",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_open_1_1Class("Confirm_open_1_1",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_close_1_1Class("Confirm_close_1_1",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_open_1_2Class("Confirm_open_1_2",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_close_1_2Class("Confirm_close_1_2",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_open_1_3Class("Confirm_open_1_3",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_close_1_3Class("Confirm_close_1_3",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_reint_pasvClass("Confirm_reint_pasv",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_close_bst_blClass("Confirm_close_bst_bl",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_set_topupClass("Confirm_set_topup",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Confirm_ack_emeClass("Confirm_ack_eme",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Echo_db50Class("Echo_db50",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"success of the request",
		Tango::OPERATOR));
	command_list.push_back(new Echo_db51Class("Echo_db51",
		Tango::DEV_VOID, Tango::DEV_STRING,
		"",
		"success of request",
		Tango::OPERATOR));
	command_list.push_back(new Echo_db121Cmd("Echo_db121",
		Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
		"",
		"result",
		Tango::OPERATOR));
	command_list.push_back(new Echo_db122Class("Echo_db122",
		Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
		"",
		"result",
		Tango::OPERATOR));
	command_list.push_back(new Gun_onClass("Gun_on",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Gun_offClass("Gun_off",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SyncronizeClass("Syncronize",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Rst_top_upCmd("Rst_top_up",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new Err_topup_rstCmd("Err_topup_rst",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		PLCaccessClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum PLCaccessClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		PLCaccessClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum PLCaccessClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		PLCaccessClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum PLCaccessClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		PLCaccessClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void PLCaccessClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new PLCaccess(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: PLCaccessClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void PLCaccessClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : Badge_ack_bo
	Badge_ack_boAttrib	*badge_ack_bo = new Badge_ack_boAttrib();
	att_list.push_back(badge_ack_bo);

	//	Attribute : Badge_ack_inj
	Badge_ack_injAttrib	*badge_ack_inj = new Badge_ack_injAttrib();
	att_list.push_back(badge_ack_inj);

	//	Attribute : Plc_status
	Plc_statusAttrib	*plc_status = new Plc_statusAttrib();
	att_list.push_back(plc_status);

	//	Attribute : Plc_timestamp
	Plc_timestampAttrib	*plc_timestamp = new Plc_timestampAttrib();
	att_list.push_back(plc_timestamp);

	//	Attribute : Msg_est_bo
	Msg_est_boAttrib	*msg_est_bo = new Msg_est_boAttrib();
	att_list.push_back(msg_est_bo);

	//	Attribute : Msg_int_bo
	Msg_int_boAttrib	*msg_int_bo = new Msg_int_boAttrib();
	att_list.push_back(msg_int_bo);

	//	Attribute : Msg_est_inj
	Msg_est_injAttrib	*msg_est_inj = new Msg_est_injAttrib();
	att_list.push_back(msg_est_inj);

	//	Attribute : Msg_int_inj
	Msg_int_injAttrib	*msg_int_inj = new Msg_int_injAttrib();
	att_list.push_back(msg_int_inj);

	//	Attribute : Version
	VersionAttrib	*version = new VersionAttrib();
	att_list.push_back(version);

	//	Attribute : Gun_trigger_on
	Gun_trigger_onAttrib	*gun_trigger_on = new Gun_trigger_onAttrib();
	att_list.push_back(gun_trigger_on);

	//	Attribute : Gun_trigger_interlock_abi
	Gun_trigger_interlock_abiAttrib	*gun_trigger_interlock_abi = new Gun_trigger_interlock_abiAttrib();
	att_list.push_back(gun_trigger_interlock_abi);

	//	Attribute : Gun_trigger_access_abi
	Gun_trigger_access_abiAttrib	*gun_trigger_access_abi = new Gun_trigger_access_abiAttrib();
	att_list.push_back(gun_trigger_access_abi);

	//	Attribute : On_topup
	On_topupAttrib	*on_topup = new On_topupAttrib();
	att_list.push_back(on_topup);

	//	Attribute : Shot_number
	Shot_numberAttrib	*shot_number = new Shot_numberAttrib();
	att_list.push_back(shot_number);

	//	Attribute : Curr_lost_short_term
	Curr_lost_short_termAttrib	*curr_lost_short_term = new Curr_lost_short_termAttrib();
	att_list.push_back(curr_lost_short_term);

	//	Attribute : Curr_lost_long_term
	Curr_lost_long_termAttrib	*curr_lost_long_term = new Curr_lost_long_termAttrib();
	att_list.push_back(curr_lost_long_term);

	//	Attribute : Max_long_time
	Max_long_timeAttrib	*max_long_time = new Max_long_timeAttrib();
	att_list.push_back(max_long_time);

	//	Attribute : Max_short_time
	Max_short_timeAttrib	*max_short_time = new Max_short_timeAttrib();
	att_list.push_back(max_short_time);

	//	Attribute : Posto_bo
	Posto_boAttrib	*posto_bo = new Posto_boAttrib();
	att_list.push_back(posto_bo);

	//	Attribute : Badge_bo
	Badge_boAttrib	*badge_bo = new Badge_boAttrib();
	att_list.push_back(badge_bo);

	//	Attribute : Posto_inj
	Posto_injAttrib	*posto_inj = new Posto_injAttrib();
	att_list.push_back(posto_inj);

	//	Attribute : Badge_inj
	Badge_injAttrib	*badge_inj = new Badge_injAttrib();
	att_list.push_back(badge_inj);

	//	Attribute : Panel_bo
	Panel_boAttrib	*panel_bo = new Panel_boAttrib();
	att_list.push_back(panel_bo);

	//	Attribute : Panel_inj
	Panel_injAttrib	*panel_inj = new Panel_injAttrib();
	att_list.push_back(panel_inj);

	//	Attribute : Dr_in_bo_stat
	Dr_in_bo_statAttrib	*dr_in_bo_stat = new Dr_in_bo_statAttrib();
	att_list.push_back(dr_in_bo_stat);

	//	Attribute : Dr_in_bo_proc
	Dr_in_bo_procAttrib	*dr_in_bo_proc = new Dr_in_bo_procAttrib();
	att_list.push_back(dr_in_bo_proc);

	//	Attribute : Dr_in_inj_stat
	Dr_in_inj_statAttrib	*dr_in_inj_stat = new Dr_in_inj_statAttrib();
	att_list.push_back(dr_in_inj_stat);

	//	Attribute : Dr_in_inj_proc
	Dr_in_inj_procAttrib	*dr_in_inj_proc = new Dr_in_inj_procAttrib();
	att_list.push_back(dr_in_inj_proc);

	//	Attribute : Alarm_door_bo
	Alarm_door_boAttrib	*alarm_door_bo = new Alarm_door_boAttrib();
	att_list.push_back(alarm_door_bo);

	//	Attribute : Alarm_door_inj
	Alarm_door_injAttrib	*alarm_door_inj = new Alarm_door_injAttrib();
	att_list.push_back(alarm_door_inj);

	//	Attribute : Lock_bo
	Lock_boAttrib	*lock_bo = new Lock_boAttrib();
	att_list.push_back(lock_bo);

	//	Attribute : Lock_inj
	Lock_injAttrib	*lock_inj = new Lock_injAttrib();
	att_list.push_back(lock_inj);

	//	Attribute : Boost_stat
	Boost_statAttrib	*boost_stat = new Boost_statAttrib();
	att_list.push_back(boost_stat);

	//	Attribute : Machine_stat
	Machine_statAttrib	*machine_stat = new Machine_statAttrib();
	att_list.push_back(machine_stat);

	//	Attribute : Rf_stat
	Rf_statAttrib	*rf_stat = new Rf_statAttrib();
	att_list.push_back(rf_stat);

	//	Attribute : Semaph_bo
	Semaph_boAttrib	*semaph_bo = new Semaph_boAttrib();
	att_list.push_back(semaph_bo);

	//	Attribute : Semaph_inj
	Semaph_injAttrib	*semaph_inj = new Semaph_injAttrib();
	att_list.push_back(semaph_inj);

	//	Attribute : Rf_enable
	Rf_enableAttrib	*rf_enable = new Rf_enableAttrib();
	att_list.push_back(rf_enable);

	//	Attribute : Bo_top_up
	Bo_top_upAttrib	*bo_top_up = new Bo_top_upAttrib();
	att_list.push_back(bo_top_up);

	//	Attribute : Abi_rf
	Abi_rfAttrib	*abi_rf = new Abi_rfAttrib();
	att_list.push_back(abi_rf);

	//	Attribute : Ring_abi
	Ring_abiAttrib	*ring_abi = new Ring_abiAttrib();
	att_list.push_back(ring_abi);

	//	Attribute : BstB_13_1
	BstB_13_1Attrib	*bst_b_13_1 = new BstB_13_1Attrib();
	att_list.push_back(bst_b_13_1);

	//	Attribute : BstBts_1_1
	BstBts_1_1Attrib	*bst_bts_1_1 = new BstBts_1_1Attrib();
	att_list.push_back(bst_bts_1_1);

	//	Attribute : BstBts_1_2
	BstBts_1_2Attrib	*bst_bts_1_2 = new BstBts_1_2Attrib();
	att_list.push_back(bst_bts_1_2);

	//	Attribute : BstBts_1_3
	BstBts_1_3Attrib	*bst_bts_1_3 = new BstBts_1_3Attrib();
	att_list.push_back(bst_bts_1_3);

	//	Attribute : Doors_1
	Doors_1Attrib	*doors_1 = new Doors_1Attrib();
	att_list.push_back(doors_1);

	//	Attribute : Doors_2
	Doors_2Attrib	*doors_2 = new Doors_2Attrib();
	att_list.push_back(doors_2);

	//	Attribute : Eme_buttons
	Eme_buttonsAttrib	*eme_buttons = new Eme_buttonsAttrib();
	att_list.push_back(eme_buttons);

	//	Attribute : Lamp
	LampAttrib	*lamp = new LampAttrib();
	att_list.push_back(lamp);

	//	Attribute : Gamma_monitor
	Gamma_monitorAttrib	*gamma_monitor = new Gamma_monitorAttrib();
	att_list.push_back(gamma_monitor);

	//	Attribute : Keys
	KeysAttrib	*keys = new KeysAttrib();
	att_list.push_back(keys);

	//	Attribute : Sir_buz
	Sir_buzAttrib	*sir_buz = new Sir_buzAttrib();
	att_list.push_back(sir_buz);

	//	Attribute : Part_bstB_13_1
	Part_bstB_13_1Attrib	*part_bst_b_13_1 = new Part_bstB_13_1Attrib();
	att_list.push_back(part_bst_b_13_1);

	//	Attribute : Part_bstB_1_1
	Part_bstB_1_1Attrib	*part_bst_b_1_1 = new Part_bstB_1_1Attrib();
	att_list.push_back(part_bst_b_1_1);

	//	Attribute : Part_bstB_1_2
	Part_bstB_1_2Attrib	*part_bst_b_1_2 = new Part_bstB_1_2Attrib();
	att_list.push_back(part_bst_b_1_2);

	//	Attribute : Part_bstB_1_3
	Part_bstB_1_3Attrib	*part_bst_b_1_3 = new Part_bstB_1_3Attrib();
	att_list.push_back(part_bst_b_1_3);

	//	Attribute : Ronda_all
	Ronda_allAttrib	*ronda_all = new Ronda_allAttrib();
	att_list.push_back(ronda_all);

	//	Attribute : Ronda_proc
	Ronda_procAttrib	*ronda_proc = new Ronda_procAttrib();
	att_list.push_back(ronda_proc);

	//	Attribute : Ronda_alm
	Ronda_almAttrib	*ronda_alm = new Ronda_almAttrib();
	att_list.push_back(ronda_alm);

	//	Attribute : Ronda_rb
	Ronda_rbAttrib	*ronda_rb = new Ronda_rbAttrib();
	att_list.push_back(ronda_rb);

	//	Attribute : Ronda_rbl
	Ronda_rblAttrib	*ronda_rbl = new Ronda_rblAttrib();
	att_list.push_back(ronda_rbl);

	//	Attribute : Ronda_barr_bst
	Ronda_barr_bstAttrib	*ronda_barr_bst = new Ronda_barr_bstAttrib();
	att_list.push_back(ronda_barr_bst);

	//	Attribute : Old_Doors_1
	Old_Doors_1Attrib	*old__doors_1 = new Old_Doors_1Attrib();
	att_list.push_back(old__doors_1);

	//	Attribute : Old_Doors_2
	Old_Doors_2Attrib	*old__doors_2 = new Old_Doors_2Attrib();
	att_list.push_back(old__doors_2);

	//	Attribute : Timers
	TimersAttrib	*timers = new TimersAttrib();
	att_list.push_back(timers);

	//	Attribute : Release_key_bo
	Release_key_boAttrib	*release_key_bo = new Release_key_boAttrib();
	att_list.push_back(release_key_bo);

	//	Attribute : Release_key_inj
	Release_key_injAttrib	*release_key_inj = new Release_key_injAttrib();
	att_list.push_back(release_key_inj);

	//	Attribute : Rf_booster
	Rf_boosterAttrib	*rf_booster = new Rf_boosterAttrib();
	att_list.push_back(rf_booster);

	//	Attribute : BstBts_2_1
	BstBts_2_1Attrib	*bst_bts_2_1 = new BstBts_2_1Attrib();
	att_list.push_back(bst_bts_2_1);

	//	Attribute : Puls_rda_np
	Puls_rda_npAttrib	*puls_rda_np = new Puls_rda_npAttrib();
	att_list.push_back(puls_rda_np);

	//	Attribute : Ronda_pt
	Ronda_ptAttrib	*ronda_pt = new Ronda_ptAttrib();
	att_list.push_back(ronda_pt);

	//	Attribute : Doors_all
	Doors_allAttrib	*doors_all = new Doors_allAttrib();
	att_list.push_back(doors_all);

	//	Attribute : Old_doors_all
	Old_doors_allAttrib	*old_doors_all = new Old_doors_allAttrib();
	att_list.push_back(old_doors_all);

	//	Attribute : Ronda_roof
	Ronda_roofAttrib	*ronda_roof = new Ronda_roofAttrib();
	att_list.push_back(ronda_roof);

	//	Attribute : Ronda_int
	Ronda_intAttrib	*ronda_int = new Ronda_intAttrib();
	att_list.push_back(ronda_int);

	//	Attribute : Ronda_dx
	Ronda_dxAttrib	*ronda_dx = new Ronda_dxAttrib();
	att_list.push_back(ronda_dx);

	//	Attribute : Ronda_sx
	Ronda_sxAttrib	*ronda_sx = new Ronda_sxAttrib();
	att_list.push_back(ronda_sx);

	//	Attribute : Old_eme_buttons
	Old_eme_buttonsAttrib	*old_eme_buttons = new Old_eme_buttonsAttrib();
	att_list.push_back(old_eme_buttons);

	//	Attribute : Ronda_names
	Ronda_namesAttrib	*ronda_names = new Ronda_namesAttrib();
	att_list.push_back(ronda_names);

	//	Attribute : Ctrl_names
	Ctrl_namesAttrib	*ctrl_names = new Ctrl_namesAttrib();
	att_list.push_back(ctrl_names);

	//	Attribute : Resettable_boards
	Resettable_boardsAttrib	*resettable_boards = new Resettable_boardsAttrib();
	att_list.push_back(resettable_boards);

	//	Attribute : Disabled_boards
	Disabled_boardsAttrib	*disabled_boards = new Disabled_boardsAttrib();
	att_list.push_back(disabled_boards);

	//	Attribute : Ronda_req_cause
	Ronda_req_causeAttrib	*ronda_req_cause = new Ronda_req_causeAttrib();
	att_list.push_back(ronda_req_cause);

	//	Attribute : Ronda_bo_fail_cause
	Ronda_bo_fail_causeAttrib	*ronda_bo_fail_cause = new Ronda_bo_fail_causeAttrib();
	att_list.push_back(ronda_bo_fail_cause);

	//	Attribute : Ronda_int_fail_cause
	Ronda_int_fail_causeAttrib	*ronda_int_fail_cause = new Ronda_int_fail_causeAttrib();
	att_list.push_back(ronda_int_fail_cause);

	//	Attribute : Ronda_roof_fail_cause
	Ronda_roof_fail_causeAttrib	*ronda_roof_fail_cause = new Ronda_roof_fail_causeAttrib();
	att_list.push_back(ronda_roof_fail_cause);

	//	Attribute : Ronda_dx_fail_cause
	Ronda_dx_fail_causeAttrib	*ronda_dx_fail_cause = new Ronda_dx_fail_causeAttrib();
	att_list.push_back(ronda_dx_fail_cause);

	//	Attribute : Ronda_sx_fail_cause
	Ronda_sx_fail_causeAttrib	*ronda_sx_fail_cause = new Ronda_sx_fail_causeAttrib();
	att_list.push_back(ronda_sx_fail_cause);

	//	Attribute : Memo_barr
	Memo_barrAttrib	*memo_barr = new Memo_barrAttrib();
	att_list.push_back(memo_barr);

	//	Attribute : Doors_ronda_all
	Doors_ronda_allAttrib	*doors_ronda_all = new Doors_ronda_allAttrib();
	att_list.push_back(doors_ronda_all);

	//	Attribute : Ronda_fail_dr
	Ronda_fail_drAttrib	*ronda_fail_dr = new Ronda_fail_drAttrib();
	att_list.push_back(ronda_fail_dr);

	//	Attribute : Part_bstB_2_1
	Part_bstB_2_1Attrib	*part_bst_b_2_1 = new Part_bstB_2_1Attrib();
	att_list.push_back(part_bst_b_2_1);

	//	Attribute : Ramping_condition
	Ramping_conditionAttrib	*ramping_condition = new Ramping_conditionAttrib();
	att_list.push_back(ramping_condition);

	//	Attribute : Curr_shot
	Curr_shotAttrib	*curr_shot = new Curr_shotAttrib();
	att_list.push_back(curr_shot);

	//	Attribute : B_current
	B_currentAttrib	*b_current = new B_currentAttrib();
	att_list.push_back(b_current);

	//	Attribute : SR_current
	SR_currentAttrib	*sr_current = new SR_currentAttrib();
	att_list.push_back(sr_current);

	//	Attribute : B_SR_current
	B_SR_currentAttrib	*b__sr_current = new B_SR_currentAttrib();
	att_list.push_back(b__sr_current);

	//	Attribute : I0_ST_current
	I0_ST_currentAttrib	*i0__st_current = new I0_ST_currentAttrib();
	att_list.push_back(i0__st_current);

	//	Attribute : INJ_ST_current
	INJ_ST_currentAttrib	*inj__st_current = new INJ_ST_currentAttrib();
	att_list.push_back(inj__st_current);

	//	Attribute : ACCU_ST_current
	ACCU_ST_currentAttrib	*accu__st_current = new ACCU_ST_currentAttrib();
	att_list.push_back(accu__st_current);

	//	Attribute : LOST_ST_current
	LOST_ST_currentAttrib	*lost__st_current = new LOST_ST_currentAttrib();
	att_list.push_back(lost__st_current);

	//	Attribute : LOST_LT_current
	LOST_LT_currentAttrib	*lost__lt_current = new LOST_LT_currentAttrib();
	att_list.push_back(lost__lt_current);

	//	Attribute : Efficiency
	EfficiencyAttrib	*efficiency = new EfficiencyAttrib();
	att_list.push_back(efficiency);

	//	Attribute : Check_topup_inj
	Check_topup_injAttrib	*check_topup_inj = new Check_topup_injAttrib();
	att_list.push_back(check_topup_inj);

	//	Attribute : Check_topup_test
	Check_topup_testAttrib	*check_topup_test = new Check_topup_testAttrib();
	att_list.push_back(check_topup_test);

	//	Attribute : Check_inj_sr
	Check_inj_srAttrib	*check_inj_sr = new Check_inj_srAttrib();
	att_list.push_back(check_inj_sr);

	//	Attribute : Check_open_bst1_1
	Check_open_bst1_1Attrib	*check_open_bst1_1 = new Check_open_bst1_1Attrib();
	att_list.push_back(check_open_bst1_1);

	//	Attribute : Check_open_bst1_2
	Check_open_bst1_2Attrib	*check_open_bst1_2 = new Check_open_bst1_2Attrib();
	att_list.push_back(check_open_bst1_2);

	//	Attribute : Check_open_bst1_3
	Check_open_bst1_3Attrib	*check_open_bst1_3 = new Check_open_bst1_3Attrib();
	att_list.push_back(check_open_bst1_3);

	//	Attribute : Check_guntr_abi
	Check_guntr_abiAttrib	*check_guntr_abi = new Check_guntr_abiAttrib();
	att_list.push_back(check_guntr_abi);

	//	Attribute : Topup_err
	Topup_errAttrib	*topup_err = new Topup_errAttrib();
	att_list.push_back(topup_err);

	//	Attribute : DBState
	DBStateAttrib	*db_state = new DBStateAttrib();
	db_state->set_change_event(true, true);
	db_state->set_archive_event(true, true);
	att_list.push_back(db_state);
	
	//	Attribute : DBError
	DBErrorAttrib	*db_error = new DBErrorAttrib();
	att_list.push_back(db_error);

	//	Attribute : Min_I_TopUp
	Min_I_TopUpAttrib	*min_i_top_up = new Min_I_TopUpAttrib();
	att_list.push_back(min_i_top_up);

	//	Attribute : Topup_GeV
	Topup_GeVAttrib	*top_up_gev = new Topup_GeVAttrib();
	att_list.push_back(top_up_gev);

	//	Attribute : Booster_board_disabled_008
	Booster_board_disabled_008Attrib	*booster_board_disabled_008 = new Booster_board_disabled_008Attrib();
	att_list.push_back(booster_board_disabled_008);
	
	//	Attribute : Booster_board_disabled_048
	Booster_board_disabled_048Attrib	*booster_board_disabled_048 = new Booster_board_disabled_048Attrib();
	att_list.push_back(booster_board_disabled_048);
	
	//	Attribute : Booster_board_disabled_064
	Booster_board_disabled_064Attrib	*booster_board_disabled_064 = new Booster_board_disabled_064Attrib();
	att_list.push_back(booster_board_disabled_064);
	
	//	Attribute : Booster_board_disabled_080
	Booster_board_disabled_080Attrib	*booster_board_disabled_080 = new Booster_board_disabled_080Attrib();
	att_list.push_back(booster_board_disabled_080);
	
	//	Attribute : Booster_board_disabled_100
	Booster_board_disabled_100Attrib	*booster_board_disabled_100 = new Booster_board_disabled_100Attrib();
	att_list.push_back(booster_board_disabled_100);
	
	//	Attribute : Booster_board_disabled_112
	Booster_board_disabled_112Attrib	*booster_board_disabled_112 = new Booster_board_disabled_112Attrib();
	att_list.push_back(booster_board_disabled_112);
	
	//	Attribute : Booster_board_disabled_118
	Booster_board_disabled_118Attrib	*booster_board_disabled_118 = new Booster_board_disabled_118Attrib();
	att_list.push_back(booster_board_disabled_118);
	
	//	Attribute : Booster_board_disabled_124
	Booster_board_disabled_124Attrib	*booster_board_disabled_124 = new Booster_board_disabled_124Attrib();
	att_list.push_back(booster_board_disabled_124);
	
	//	Attribute : Booster_board_disabled_130
	Booster_board_disabled_130Attrib	*booster_board_disabled_130 = new Booster_board_disabled_130Attrib();
	att_list.push_back(booster_board_disabled_130);
	
	//	Attribute : Booster_board_disabled_136
	Booster_board_disabled_136Attrib	*booster_board_disabled_136 = new Booster_board_disabled_136Attrib();
	att_list.push_back(booster_board_disabled_136);
	
	//	Attribute : Booster_board_disabled_142
	Booster_board_disabled_142Attrib	*booster_board_disabled_142 = new Booster_board_disabled_142Attrib();
	att_list.push_back(booster_board_disabled_142);
	
	//	Attribute : Booster_board_disabled_148
	Booster_board_disabled_148Attrib	*booster_board_disabled_148 = new Booster_board_disabled_148Attrib();
	att_list.push_back(booster_board_disabled_148);
	
	//	Attribute : Booster_board_disabled_223
	Booster_board_disabled_223Attrib	*booster_board_disabled_223 = new Booster_board_disabled_223Attrib();
	att_list.push_back(booster_board_disabled_223);
	
	//	Attribute : Booster_board_disabled_229
	Booster_board_disabled_229Attrib	*booster_board_disabled_229 = new Booster_board_disabled_229Attrib();
	att_list.push_back(booster_board_disabled_229);
	
	//	Attribute : Booster_board_disabled_235
	Booster_board_disabled_235Attrib	*booster_board_disabled_235 = new Booster_board_disabled_235Attrib();
	att_list.push_back(booster_board_disabled_235);
	
	//	Attribute : Booster_board_disabled_247
	Booster_board_disabled_247Attrib	*booster_board_disabled_247 = new Booster_board_disabled_247Attrib();
	att_list.push_back(booster_board_disabled_247);
	
	//	Attribute : Booster_board_disabled_253
	Booster_board_disabled_253Attrib	*booster_board_disabled_253 = new Booster_board_disabled_253Attrib();
	att_list.push_back(booster_board_disabled_253);
	
	//	Attribute : Booster_board_disabled_259
	Booster_board_disabled_259Attrib	*booster_board_disabled_259 = new Booster_board_disabled_259Attrib();
	att_list.push_back(booster_board_disabled_259);
	
	//	Attribute : Booster_board_disabled_265
	Booster_board_disabled_265Attrib	*booster_board_disabled_265 = new Booster_board_disabled_265Attrib();
	att_list.push_back(booster_board_disabled_265);
	
	//	Attribute : Booster_board_disabled_278
	Booster_board_disabled_278Attrib	*booster_board_disabled_278 = new Booster_board_disabled_278Attrib();
	att_list.push_back(booster_board_disabled_278);
	
	//	Attribute : Booster_board_disabled_291
	Booster_board_disabled_291Attrib	*booster_board_disabled_291 = new Booster_board_disabled_291Attrib();
	att_list.push_back(booster_board_disabled_291);
	
	//	Attribute : Booster_board_disabled_304
	Booster_board_disabled_304Attrib	*booster_board_disabled_304 = new Booster_board_disabled_304Attrib();
	att_list.push_back(booster_board_disabled_304);
	
	//	Attribute : Booster_board_disabled_310
	Booster_board_disabled_310Attrib	*booster_board_disabled_310 = new Booster_board_disabled_310Attrib();
	att_list.push_back(booster_board_disabled_310);
	
	//	Attribute : Booster_board_disabled_316
	Booster_board_disabled_316Attrib	*booster_board_disabled_316 = new Booster_board_disabled_316Attrib();
	att_list.push_back(booster_board_disabled_316);
	
	//	Attribute : Booster_board_disabled_321
	Booster_board_disabled_321Attrib	*booster_board_disabled_321 = new Booster_board_disabled_321Attrib();
	att_list.push_back(booster_board_disabled_321);
	
	//	Attribute : Booster_board_disabled_333
	Booster_board_disabled_333Attrib	*booster_board_disabled_333 = new Booster_board_disabled_333Attrib();
	att_list.push_back(booster_board_disabled_333);
	
	//	Attribute : Booster_board_disabled_339
	Booster_board_disabled_339Attrib	*booster_board_disabled_339 = new Booster_board_disabled_339Attrib();
	att_list.push_back(booster_board_disabled_339);
	
	//	Attribute : Booster_board_disabled_345
	Booster_board_disabled_345Attrib	*booster_board_disabled_345 = new Booster_board_disabled_345Attrib();
	att_list.push_back(booster_board_disabled_345);

	//	Attribute : BTSReal
	BTSRealAttrib	*bts_real = new BTSRealAttrib();
	att_list.push_back(bts_real);

	//	Attribute : BTSBool
	BTSBoolAttrib	*bts_bool = new BTSBoolAttrib();
	att_list.push_back(bts_bool);

	//	Attribute : I_BTS_Thresh_2Gev
	I_BTS_Thresh_2GevAttrib	*i_bts_thresh_2gev = new I_BTS_Thresh_2GevAttrib();
	att_list.push_back(i_bts_thresh_2gev);

	//	Attribute : I_BTS_Thresh_2_4Gev
	I_BTS_Thresh_2_4GevAttrib	*i_bts_thresh_2_4gev = new I_BTS_Thresh_2_4GevAttrib();
	att_list.push_back(i_bts_thresh_2_4gev);

	//	Attribute : I_BTS
	I_BTSAttrib	*i_bts = new I_BTSAttrib();
	att_list.push_back(i_bts);

	//	Attribute : I_MAX_Lost
	I_MAX_LostAttrib	*i_max_lost = new I_MAX_LostAttrib();
	att_list.push_back(i_max_lost);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}


//+----------------------------------------------------------------------------
//
// method : 		PLCaccessClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void PLCaccessClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;



	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	PLCaccessClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void PLCaccessClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "Ipaddr";
	prop_desc = "ip address of PLC";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Plc_port";
	prop_desc = "tcp port for communication with PLC";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Timeout";
	prop_desc = "max time in ms between two messages from PLC";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Db_param";
	prop_desc = "host, user, passw, port for db log connection";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Hbeat";
	prop_desc = "string containing the timeout in msec of db50 and db51 data received from plc";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		PLCaccessClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void PLCaccessClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("access control PLC manager");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("manages I/O with PLC of access control");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
